unit SoudTest;
// (c)2006 by Paul TOTH <tothpaul@free.fr>
// http://tothpaul.free.fr

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MMSystem, ExButtons, g711a, ComCtrls;

type
  TPCMATest=class(TCustomPCMA)
  public
   procedure Close; override;
  end;

  TSoundTest = class(TForm)
    WaveIn: TLabel;
    WaveOut: TLabel;
    Graph: TPaintBox;
    Test: TButton;
    Status: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;
    ProgressBar: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure GraphPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
    PCMA:TPCMATest;
    Stream:TMemoryStream;
    procedure WAVEInData(Var Msg:TMessage); message MM_WIM_DATA; // waveIn callback message
  public
    { Public declarations }
  end;

var
  SoundTest: TSoundTest;

function DrawSound(data:pchar; Canvas:TCanvas; Color:TColor):integer;

implementation

uses main;

{$R *.dfm}

//----------------------------------------------------------------------------//
function DrawSound(data:pchar; Canvas:TCanvas; Color:TColor):integer;
var
 s  :^smallint;
 amp:integer;
 absamp:integer;
 i:integer;
begin
 with Canvas do begin
  Brush.Color:=clBlack;
  Pen.color:=clBlack;
  Rectangle(0,0,240,50);
  Pen.Color:=Color;
  MoveTo(0,25);
  s:=pointer(data);
  Result:=0;
  for i:=0 to 239 do begin
   amp:=round(50*s^/$7fff);
   LineTo(i,25+amp);
   absamp:=abs(amp);
   if absamp>Result then Result:=absamp;
   inc(s);
  end;
 end;
end;

//----------------------------------------------------------------------------//
procedure TPCMATest.Close;
begin
 CloseIn;
 CloseOut;
end;

//----------------------------------------------------------------------------//

procedure TSoundTest.FormCreate(Sender: TObject);
begin
 PCMA:=TPCMATest.Create(Handle);
 WaveIn.Caption :='Sortie: '+MainForm.Options.WaveInName;
 WaveOut.Caption:='Entre: '+MainForm.Options.WaveOutName;
 PCMA.DevOut:=MainForm.Options.WaveOutList.ItemIndex;
 PCMA.DevIn :=MainForm.Options.WaveInList.ItemIndex;
 Status.Caption:='Parlez dans le micro...';
 Stream:=TMemoryStream.Create;
 if not PCMA.OpenIn then ShowMessage('Impossible d''ouvrir le micro');
end;

procedure TSoundTest.GraphPaint(Sender: TObject);
begin
 with Graph,Canvas do begin
  Brush.Color:=clBlack;
  FillRect(ClientRect);
 end;
end;

procedure TSoundTest.FormDestroy(Sender: TObject);
begin
 PCMA.Free;
end;

procedure TSoundTest.WAVEInData(Var Msg:TMessage);
// waveIn callback
var
 Header:PWaveHdr;
begin
// on en profite pour mettre  jour le Timer
 ProgressBar.StepIt;
// on y va
 Header:=pointer(Msg.LParam);
 DrawSound(Header.lpData,Graph.Canvas,clLime);
 Stream.WriteBuffer(Header.lpData^,Header.dwBufferLength);
 waveInAddBuffer(Msg.wParam,Header,SizeOf(TWaveHdr));
end;

procedure TSoundTest.Timer1Timer(Sender: TObject);
begin
 ProgressBar.Position:=0;
 Timer1.Enabled:=False;
 Stream.Position:=0;
 PCMA.CloseIn;
 if not PCMA.OpenOut then begin
  ShowMessage('Impossible de jouer le son');
 end else begin
  Status.Caption:='Ecoutez votre voix';
  Timer2.Enabled:=True;
 end;
end;

procedure TSoundTest.Timer2Timer(Sender: TObject);
var
 s:string;
begin
 ProgressBar.StepIt;
 SetLength(s,OUT_SIZE);
 if Stream.Read(s[1],OUT_SIZE)=OUT_SIZE then begin
  DrawSound(@s[1],Graph.Canvas,clRed);
  PCMA.Play(s);
 end else begin
  Stream.Position:=0;
  ProgressBar.Position:=0;
  Timer2.Enabled:=False;
  PCMA.CloseOut;
  if PCMA.OpenIn then begin
   Timer1.Enabled:=True;
  end else begin
   ShowMessage('Impossible d''ouvrir le micro');
  end;
  Status.Caption:='Parlez dans le micro';
 end;
end;

end.

